from rq_controller.common import PyVolume
from rq_controller.common.io.rq_json import RqJsonWriter, RqJsonLoader
from pathlib import Path
import numpy as np


FOLDER = Path("./example/data")


def main():
    volume = PyVolume.dummy()
    print(f"Shape (x / y / z): {volume.shape}")
    msg = volume.as_message()
    print(f"Number of slices: {len(msg.slices)}")

    volume_2 = PyVolume.from_message(msg)
    print(f"Shape (x / y / z): {volume_2.shape}")

    writer = RqJsonWriter()
    writer.write_volume(writer.get_volume_save_path_i(FOLDER, 1), volume_2)

    loader = RqJsonLoader()
    volume_3 = loader.load_volume(writer.get_volume_save_path_i(FOLDER, 1))
    print(f"Shape (x / y / z): {volume_3.shape}")

    grid = volume_3.roi.get_grid()
    print(f"grid shape: {grid.shape}")

    pos = volume_3.roi.next_neighbor(grid, np.array([0.0, 0.0, 0.0]))
    print(pos)
    value = volume_3.array[pos[0], pos[1], pos[2]]
    print(value)


if __name__ == "__main__":
    main()
