from pathlib import Path
from ...common import PyProjectionGeometry, PyProjection, PyRegionOfIntrest, PyVolume


class BaseDataLoader:
    def __init__(
        self,
        porjection_geometry_suffix: str,
        projection_suffix: str,
        region_of_intrest_suffix: str,
        volume_suffix: str,
    ):
        self.porjection_geometry_suffix = porjection_geometry_suffix
        self.projection_suffix = projection_suffix
        self.region_of_intrest_suffix = region_of_intrest_suffix
        self.volume_suffix = volume_suffix

    def load_projection_geometry(self, load_path: Path) -> PyProjectionGeometry:
        raise NotImplementedError()

    def load_projection(self, load_path: Path) -> PyProjection:
        raise NotImplementedError()

    def load_region_of_intrest(self, load_path: Path) -> PyRegionOfIntrest:
        raise NotImplementedError()

    def load_volume(self, load_path: Path) -> PyVolume:
        raise NotImplementedError()
